	list      p=12f629           ; list directive to define processor
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _CPD_OFF & _BODEN_ON & _MCLRE_ON & _WDT_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 
	__IDLOCS	H'0100'			;V1.00, 15 SEP 2000
	INCLUDE OUT_0.ASM
BANK0		macro
		bcf	STATUS,RP0
		endm

BANK1		macro
		bsf	STATUS,RP0
		endm
AN0		EQU	0		; do
VREF		EQU	1		; A/Dd
CHG		EQU	2		; [dw
TX		EQU	4		; f[^Mo
LED1		EQU	5		; (out) dr1ԕ\LED(High=_)
	INCLUDE r_tr_3.asm
	ORG	0
	GOTO	START

	ORG	4
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	ST_TEMP
		NOP
		MOVLW	D'15'
		MOVWF	TMR0
		DECF	INT_CNT,F
		SKPZ
		GOTO	IL1
		MOVLW	D'39'	;		
		MOVWF	INT_CNT		
		BSF	SF0,7		;SCAN START FLAG=ON
	IL1
		MOVF	ST_TEMP,W
		MOVWF	STATUS
		MOVF	W_TEMP,W
		BCF	INTCON,T0IF
		RETFIE
init
		clrf	INTCON
	BANK0
		movlw	b'00000000'
		movwf	GPIO		; Init GPIO
		movlw	b'00000111'	; Comparator not used
		movwf	CMCON		; set CMCON
	BANK1
		movlw	b'00011000'	; Set I/O
		movwf	TRISIO
		return
INPUT	MOVF	X0_WK1,W
	MOVWF	WF1
	CLRW
	BTFSS	GPIO,0		;X0,0
	XORLW	B'00000001'
	XORLW	B'00000001'
	BTFSS	GPIO,1		;X0,1
	XORLW	B'00000010'
	XORLW	B'00000010'
	BTFSS	GPIO,2		;X0,2
	XORLW	B'00000100'
	XORLW	B'00000100'
	BTFSS	GPIO,3		;X0,3
	XORLW	B'00001000'
	XORLW	B'00001000'
	BTFSS	GPIO,4		;X0,4
	XORLW	B'00010000'
	XORLW	B'00010000'
	BTFSS	GPIO,5		;X0,5
	XORLW	B'00100000'
	XORLW	B'00100000'
	MOVWF	X0_WK1
	ANDWF	WF1,W
	IORWF	X0,F
	MOVF	X0_WK1,W
	IORWF	WF1,W
	ANDWF	X0,F
	COMF	X0,F
	BTFSC	SF0,6
	CLRF	X0
	RETURN
	WAIT13	MOVLW	D'8'
		MOVWF	WF2
	WAIT131	DECFSZ	WF2,F
		GOTO	WAIT131
		RETURN
	START	
main
		call	h'3FF'		; retrieve factory calibration value
	BANK1
		movwf	OSCCAL		; update register with factory cal value 
	BANK0
		call	init
		BSF	STATUS,RP0	;option_reg.  
		MOVLW	B'11011111'	;bit 7 : PORTB pullup  1=disable, 0=enable
		MOVWF	OPTION_REG	;    6 : RB0 pin interrupt Edge  
		BCF	STATUS,RP0	;    5 : TMR0 clock source  1=RA4 pin, 0=internal CLK
	MOVLW	B'00100000'	;bit 7 : GIE interrupt  1=enable, 0=disable
	MOVWF	INTCON		;    6 : EEIE(F84) -> PEIE(F873)
	BCF	STATUS,RP0
	MOVLW	H'24'
	MOVWF	FSR
	MOVLW	H'5F'-H'24'		;020918
	MOVWF	WF1
CLRMEM1	CLRF	INDF
	INCF	FSR,F
	DECFSZ	WF1,F
	GOTO	CLRMEM1
	ifdef	ZIKAN_TM26_2M
		MOVLW	D'3'		;KEISOKU 1KAI/2MIN 
	endif
	ifdef	ZIKAN_TM26_3M
		MOVLW	D'4'		;KEISOKU 1KAI/3MIN 
	endif
	ifdef	ZIKAN_TM26_5M
		MOVLW	D'6'		;KEISOKU 1KAI/5MIN D'5'->4,9
	endif
	ifdef	ZIKAN_TM26_10M
		MOVLW	D'11'		;KEISOKU 1KAI/10MIN 
	endif
	ifdef	ZIKAN_TM26_20M
		MOVLW	D'21'		;KEISOKU 1KAI/20MIN 
	endif
	ifdef	ZIKAN_TM26_30M
		MOVLW	D'31'		;KEISOKU 1KAI/30MIN 
	endif
		INCF	SF1,F	;SCAN COUNTER 
		BSF	SF0,6		;INIT PULSE (Pow on 1 scan)=ON

		MOVLW	D'100'		;ladder D'100'
		MOVWF	INT_CNT

		CALL	INPUT
		CALL	INPUT

		BSF	INTCON,GIE
IDLE	
	CLRWDT
	BTFSC	SF0,7	;SCAN START FLAG == ON?
	GOTO	MAIN_SCAN
	GOTO	IDLE
MAIN_SCAN
	CALL	INPUT
	MOVF	DR0,W
	XORWF	DR0_WK,W
	ANDWF	DR0,W
	MOVWF	DU0
	MOVF	DR0,W
	XORWF	DR0_WK,W
	ANDWF	DR0_WK,W
	MOVWF	DD0
	MOVF	DR0,W
	MOVWF	DR0_WK
		INCLUDE kairo_8.asm	;GP4->GP0 ON-OFF CLOCK
	ifdef	ZIKAN_1S
	endif
	ifdef	ZIKAN_10S
	endif
	ifdef	ZIKAN_30S
	endif
	ifdef	ZIKAN_1M
	endif
	ifdef	ZIKAN_2M
	endif
	ifdef	ZIKAN_3M
	endif
	ifdef	ZIKAN_5M
	endif
	ifdef	ZIKAN_20M
	endif
	ifdef	ZIKAN_30M
	endif
	IDLE_2
	CLRF	WF1
	BTFSS	Y0,0
	GOTO	Y0_0
	BSF	WF1,0
Y0_0	BTFSS	Y0,1
	GOTO	Y0_1
	BSF	WF1,1
Y0_1	BTFSS	Y0,2
	GOTO	Y0_2
	BSF	WF1,2
Y0_2	BTFSS	Y0,3
	GOTO	Y0_3
	BSF	WF1,3
Y0_3	BTFSS	Y0,4
	GOTO	Y0_4
	BSF	WF1,4
Y0_4	BTFSS	Y0,5
	GOTO	Y0_5
	BSF	WF1,5  
Y0_5
	MOVF	WF1,W
	MOVWF	GPIO
	BCF	SF0,7	;SCAN START FLAG =OFF
	BCF	SF0,6	;INIT PULSE (Pow on 1 scan)=off
	GOTO	IDLE
	END
